Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/C1D_PAPA/cpp_C1D_PAPA.fcm
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/C1D_PAPA/cpp_C1D_PAPA.fcm	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/C1D_PAPA/cpp_C1D_PAPA.fcm	(revision 4247)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_c1d key_dynspg_flt key_diahth key_zdfgls key_iomput
+ bld::tool::fppkeys key_c1d key_dynspg_flt key_diahth key_zdfgls key_iomput key_mpp_mpi
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/cfg.txt
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/cfg.txt	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/CONFIG/cfg.txt	(revision 4247)
@@ -1,11 +1,11 @@
-GYRE OPA_SRC
 GYRE_BFM OPA_SRC TOP_SRC
 GYRE_PISCES OPA_SRC TOP_SRC
+ORCA2_LIM3 OPA_SRC LIM_SRC_3 NST_SRC
+ORCA2_LIM_CFC_C14b OPA_SRC LIM_SRC_2 NST_SRC TOP_SRC
+GYRE OPA_SRC
+ORCA2_LIM_PISCES OPA_SRC LIM_SRC_2 NST_SRC TOP_SRC
+ORCA2_OFF_PISCES OPA_SRC OFF_SRC TOP_SRC
+ORCA2_SAS_LIM OPA_SRC SAS_SRC LIM_SRC_2 NST_SRC
 AMM12 OPA_SRC
 ORCA2_LIM OPA_SRC LIM_SRC_2 NST_SRC
-ORCA2_LIM3 OPA_SRC LIM_SRC_3 NST_SRC
-ORCA2_SAS_LIM OPA_SRC SAS_SRC LIM_SRC_2 NST_SRC
-ORCA2_LIM_CFC_C14b OPA_SRC LIM_SRC_2 NST_SRC TOP_SRC
-ORCA2_OFF_PISCES OPA_SRC OFF_SRC TOP_SRC
-ORCA2_LIM_PISCES OPA_SRC LIM_SRC_2 NST_SRC TOP_SRC
 C1D_PAPA OPA_SRC
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90	(revision 4247)
@@ -16,4 +16,5 @@
    USE in_out_manager   ! I/O manager
    USE par_kind         ! kind parameters
+   USE lib_mpp
 
    IMPLICIT NONE
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90	(revision 4247)
@@ -60,7 +60,7 @@
 
                              indic = 0                ! reset to no error condition
-      IF( kstp == nit000 )   CALL iom_init            ! iom_put initialization (must be done after nemo_init for AGRIF+XIOS+OASIS)
+      IF( kstp == nit000 )   CALL iom_init( "nemo")   ! iom_put initialization (must be done after nemo_init for AGRIF+XIOS+OASIS)
       IF( kstp /= nit000 )   CALL day( kstp )         ! Calendar (day was already called at nit000 in day_init)
-                             CALL iom_setkt( kstp - nit000 + 1 )   ! say to iom that we are at time step kstp
+                             CALL iom_setkt( kstp - nit000 + 1, "nemo" )   ! say to iom that we are at time step kstp
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4247)
@@ -35,5 +35,5 @@
    USE crs            ! domain for coarse grid
    USE in_out_manager 
-   USE par_kind, ONLY: wp
+   USE par_kind
    USE crslbclnk
    
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 4247)
@@ -30,4 +30,5 @@
    !                                    !!* Namelist namdom : time & space domain *
    INTEGER , PUBLIC ::   nn_bathy        !: = 0/1 ,compute/read the bathymetry file
+   REAL(wp), PUBLIC ::   rn_bathy        !: depth of flat bottom (active if nn_bathy=0; if =0 depth=jpkm1)
    REAL(wp), PUBLIC ::   rn_hmin         !: minimum ocean depth (>0) or minimum number of ocean levels (<0)
    REAL(wp), PUBLIC ::   rn_e3zps_min    !: miminum thickness for partial steps (meters)
Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 4245)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 4247)
@@ -49,11 +49,11 @@
 
    !                               !!* Namelist namtra_dmp : T & S newtonian damping *
-   LOGICAL, PUBLIC ::   ln_tradmp   !: internal damping flag
-   INTEGER         ::   nn_hdmp     ! = 0/-1/'latitude' for damping over T and S
-   INTEGER         ::   nn_zdmp     ! = 0/1/2 flag for damping in the mixed layer
-   REAL(wp)        ::   rn_surf     ! surface time scale for internal damping        [days]
-   REAL(wp)        ::   rn_bot      ! bottom time scale for internal damping         [days]
-   REAL(wp)        ::   rn_dep      ! depth of transition between rn_surf and rn_bot [meters]
-   INTEGER         ::   nn_file     ! = 1 create a damping.coeff NetCDF file 
+   LOGICAL , PUBLIC ::   ln_tradmp   !: internal damping flag
+   INTEGER , PUBLIC ::   nn_hdmp     ! = 0/-1/'latitude' for damping over T and S
+   INTEGER , PUBLIC ::   nn_zdmp     ! = 0/1/2 flag for damping in the mixed layer
+   REAL(wp), PUBLIC ::   rn_surf     ! surface time scale for internal damping        [days]
+   REAL(wp), PUBLIC ::   rn_bot      ! bottom time scale for internal damping         [days]
+   REAL(wp), PUBLIC ::   rn_dep      ! depth of transition between rn_surf and rn_bot [meters]
+   INTEGER , PUBLIC ::   nn_file     ! = 1 create a damping.coeff NetCDF file 
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   strdmp   !: damping salinity trend (psu/s)