Index: branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/SETTE/sette.sh
===================================================================
--- branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/SETTE/sette.sh	(revision 4249)
+++ branches/2013/dev_LOCEAN_CMCC_INGV_MERC_UKMO_2013/NEMOGCM/SETTE/sette.sh	(revision 4252)
@@ -144,7 +144,7 @@
     . ./makenemo -m ${CMP_NAM} -n GYRE_LONG -r GYRE -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
@@ -170,5 +170,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"GYRE_SHORT\"
@@ -211,7 +211,7 @@
     . ./makenemo -m ${CMP_NAM} -n GYRE_4 -r GYRE -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
@@ -241,5 +241,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_2_2"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
@@ -275,7 +275,7 @@
     . ./makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_LONG -r ORCA2_LIM_PISCES -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
@@ -313,5 +313,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"O2LP_SHORT\"
@@ -368,7 +368,7 @@
     . ./makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_16 -r ORCA2_LIM_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=16
@@ -410,5 +410,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_2_8"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=16
@@ -455,7 +455,7 @@
     . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_LONG -r ORCA2_OFF_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=4
@@ -494,5 +494,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"OFFP_SHORT\"
@@ -542,7 +542,7 @@
     . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_16 -r ORCA2_OFF_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=16
@@ -582,5 +582,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_2_8"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=16
@@ -626,7 +626,7 @@
     . ./makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 add_key "key_tide" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -634,6 +634,6 @@
     cd ${EXE_DIR}
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 12
-    set_namelist namelist_cfg nn_stock 6
+    set_namelist namelist_cfg nn_itend 576
+    set_namelist namelist_cfg nn_stock 288
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg ln_ctl .false.
@@ -641,6 +641,4 @@
     set_namelist namelist_cfg nn_dyn2d 2
     set_namelist namelist_cfg nn_tra_dta 0
-    set_namelist namelist_cfg cn_ocerst_in \"amm12_restart_oce\"
-    ln -s restarts/amm12_restart_oce.nc amm12_restart_oce.nc
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
@@ -658,6 +656,6 @@
     . prepare_exe_dir.sh
     cd ${EXE_DIR}
-    set_namelist namelist_cfg nn_it000 7
-    set_namelist namelist_cfg nn_itend 12
+    set_namelist namelist_cfg nn_it000 289
+    set_namelist namelist_cfg nn_itend 576
     set_namelist namelist_cfg nn_fwb 0
     set_namelist namelist_cfg ln_ctl .false.
@@ -670,9 +668,10 @@
     set_namelist namelist_cfg ln_rstart .true.
     set_namelist namelist_cfg nn_rstctl 2
-    set_namelist namelist_cfg cn_ocerst_in \"AMM12_00000006_restart_oce_out\"
+    set_namelist namelist_cfg cn_ocerst_in \"AMM12_00000288_restart_oce_out\"
+    set_namelist namelist_cfg nn_date0 20120102
     for (( i=1; i<=$NPROC; i++)) ; do
         L_NPROC=$(( $i - 1 ))
         L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/AMM12_00000006_restart_oce_out_${L_NPROC}.nc .
+        ln -sf ../LONG/AMM12_00000288_restart_oce_out_${L_NPROC}.nc .
     done
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -693,7 +692,7 @@
     . ./makenemo -m ${CMP_NAM} -n AMM12_32 -r AMM12 -j 8 add_key "key_mpp_rep key_tide" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -707,5 +706,4 @@
     set_namelist namelist_cfg nn_dyn2d 2
     set_namelist namelist_cfg nn_tra_dta 0
-    set_namelist namelist_cfg cn_ocerst_in \"amm12_restart_oce\"
     ln -s restarts/amm12_restart_oce.nc amm12_restart_oce.nc
     set_namelist namelist_cfg jpni 8
@@ -724,5 +722,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_4_8"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg nn_it000 1
@@ -757,7 +755,7 @@
     . ./makenemo -m ${CMP_NAM} -n SAS_LONG -r ORCA2_SAS_LIM -j 8 "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -783,5 +781,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="SHORT"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
@@ -817,7 +815,7 @@
     . ./makenemo -m ${CMP_NAM} -n SAS_32 -r ORCA2_SAS_LIM -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -843,5 +841,5 @@
     cd ${SETTE_DIR}
     export TEST_NAME="REPRO_4_8"
-    . prepare_exe_dir.sh
+    . ./prepare_exe_dir.sh
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
@@ -871,7 +869,7 @@
     . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_1_2 -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
-    . param.cfg
-    . all_functions.sh
-    . prepare_exe_dir.sh
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=2