Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/ARCH/arch-ALTIX_NAUTILUS_MPT.fcm
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/ARCH/arch-ALTIX_NAUTILUS_MPT.fcm	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/ARCH/arch-ALTIX_NAUTILUS_MPT.fcm	(revision 4263)
@@ -47,5 +47,5 @@
 %LD                  ifort
 %FPPFLAGS            -P -C -traditional
-%LDFLAGS             -lmpi -lstdc++
+%LDFLAGS             -lmpi -lstdc++ -lcurl
 %AR                  ar 
 %ARFLAGS             -r
Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 4263)
@@ -599,5 +599,8 @@
       WRITE(*,*) 'bdytide_update: You should not have seen this print! error?', kt, jit
    END SUBROUTINE bdytide_update
-   SUBROUTINE bdy_dta_tides( kt, jit )   ! Empty routine
+   SUBROUTINE bdy_dta_tides( kt, kit, time_offset )     ! Empty routine
+      INTEGER, INTENT( in )            ::   kt          ! Dummy argument empty routine      
+      INTEGER, INTENT( in ),OPTIONAL   ::   kit         ! Dummy argument empty routine
+      INTEGER, INTENT( in ),OPTIONAL   ::   time_offset ! Dummy argument empty routine
       WRITE(*,*) 'bdy_dta_tides: You should not have seen this print! error?', kt, jit
    END SUBROUTINE bdy_dta_tides
Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 4263)
@@ -74,14 +74,4 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  ftsw, ftse   ! (only used with een vorticity scheme)
 
-   ! Would be convenient to have arrays below defined whatever the free surface option ?
-   ! These could be computed once for all at the beginning of the each baroclinic time step
-   ! and eventually swapped at the end
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ua_b, va_b     ! after  averaged velocities
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   un_b, vn_b     ! now    averaged velocities
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ub_b, vb_b     ! before averaged velocities
-
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   un_adv, vn_adv ! Advection vel. at "now" barocl. step
-   REAL(wp), PRIVATE,ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ub2_b,  vb2_b  ! Advection vel. at "now-0.5" barocl. step
-
    ! Arrays below are saved to allow testing of the "no time averaging" option
    ! If this option is not retained, these could be replaced by temporary arrays
Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 4263)
@@ -26,5 +26,5 @@
    USE timing          ! Timing
    USE dynadv          ! dynamics: vector invariant versus flux form
-   USE dynspg_oce, ONLY: lk_dynspg_ts
+   USE dynspg_oce, ONLY: lk_dynspg_ts, ua_b, va_b
    USE dynspg_ts
 
Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 4263)
@@ -36,5 +36,6 @@
    USE iom
    USE sbcrnf, ONLY: h_rnf, nk_rnf, sbc_rnf_div   ! River runoff 
-   USE dynspg_ts,  ONLY: un_b, vn_b, un_adv, vn_adv, ln_bt_fw
+   USE dynspg_oce,  ONLY: un_b, vn_b, un_adv, vn_adv
+   USE dynspg_ts,   ONLY: ln_bt_fw
    USE dynspg_oce, ONLY: lk_dynspg_ts
 #if defined key_agrif
Index: branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 4262)
+++ branches/2013/dev_r3858_NOC_ZTC/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 4263)
@@ -24,5 +24,6 @@
    PRIVATE
 
-   PUBLIC   sbc_ssm    ! routine called by step.F90
+   PUBLIC   sbc_ssm         ! routine called by step.F90
+   PUBLIC   sbc_ssm_init    ! routine called by sbcmod.F90
 
    LOGICAL, SAVE  ::   l_ssm_mean = .FALSE.       ! keep track of whether means have been read